#!/usr/bin/env python

import optparse, os, sys

name = "iTango"
usage = "Usage: ./install.py [-v] HOST"
bundle = "iTango.theme"

p = optparse.OptionParser(
	description="Installs the %s WinterBoard theme onto your iPhone or iPod Touch." % name,
	prog='install.py',
	usage = usage + "\nwhere HOST is the IP address or hostname of your device.")
p.add_option(
	"--verbose",
	"-v",
	dest="verbose",
	default=False,
	action="store_true",
	help="print detailed information about the file copying process.")
options, args = p.parse_args()

if len(args) == 1:
	host = args[0]
elif len(args) == 0:
	print sys.argv[0] + ": error: no host specified\n"
	p.print_help()
	sys.exit(2)

print "Copying " + name + " to your device (%s)..." % host
if options.verbose == True:
	rsync_cmd = "rsync -avz --delete Dist/%s root@%s:/Library/Themes" % (bundle, host)
else:
	rsync_cmd = "rsync -az --delete Dist/%s root@%s:/Library/Themes" % (bundle, host)
clean_cmd = "ssh root@%s \"if [ -d \\\"/Library/Themes/%s\\\" ]; then; echo \\\"Removing an old version of %s from your device...\\\"; rm -r \\\"/Library/Themes/%s\\\"; fi\"" % (host, name, name, name)
copy_error = "Problem copying %s to your device.  Is it connected to your network?" % name
clean_error = "Problem removing an old version of %s to your device.  Is it connected to\nyour network?" % name
if os.system(rsync_cmd) != 0:
	print copy_error
	sys.exit(1)
if options.verbose == True:
	print ""
if os.system(clean_cmd) != 0:
	print clean_error
	sys.exit(1)

print "Restarting SpringBoard on your device..."
restart_cmd = "ssh root@%s \"killall -2 SpringBoard\"" % host
if os.system(restart_cmd) != 0:
	print "Problem restarting SpringBoard on your device."
	sys.exit(1)

print """\n%s has been installed to your device or upgraded successfully!  Please
open WinterBoard and select %s if you haven't already.  Enjoy!""" % (name, name)
